=== debian/tests/control ===
Test-Command: box64 --version
Depends:
 box64,
Restrictions:
 allow-stderr,
 superficial,
